Draft Downgrade: Difference between revisions

From FreeCAD Documentation
(Removed Example)
(Removed 'according to the following conditions, in order'. The decision 'tree' of the command is too complex.)
Line 47: Line 47:
#* Press the {{KEY|D}} then {{KEY|N}} keyboard shortcut
#* Press the {{KEY|D}} then {{KEY|N}} keyboard shortcut
#* Use the {{MenuCommand|Modification → Downgrade}} entry in the Draft menu
#* Use the {{MenuCommand|Modification → Downgrade}} entry in the Draft menu
:Note: If no object is selected, you will be invited to select one.

<!--T:17-->
The selected objects are modified or downgraded, according to the following conditions, in order:
# If only one object is selected and it contains more than one face, each face becomes a separate object.
# If there are more than one face in the selection, the subsequent objects are subtracted from the first one. This modification is similar to {{Button|[[Image:Part_Cut.svg|16px]] [[Part_Cut|Part Cut]]}}.
# If there is only one face in the selection, it gets converted into a wire.
# Otherwise all wires found in the selection are exploded into single edges.


==Scripting== <!--T:22-->
==Scripting== <!--T:22-->

Revision as of 11:50, 10 June 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft Downgrade

Menu location
Modification → Downgrade
Workbenches
Draft, Arch
Default shortcut
D N
Introduced in version
-
See also
Draft Upgrade, Part Cut

Description

The Draft Downgrade tool downgrades the selected objects in different ways.

The Downgrade tool performs things such as breaking faces, and deconstructing wires into their individual edges. It can cut a shape with another shape in similar way to Part Cut.

The counterpart to this tool is the Draft Upgrade operation.

Face cut from another face; then face downgraded into a closed wire; then downgraded into individual lines

Usage

  1. Select one or more objects that you want to downgrade.
  2. There are several ways to invoke the command:
    • Press the Draft Downgrade button in the Draft toolbar
    • Press the D then N keyboard shortcut
    • Use the Modification → Downgrade entry in the Draft menu

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To downgrade objects use the downgrade method of the Draft module.

downgrade_list = downgrade(objects, delete=False, force=None)
  • objects contains the objects to be downgraded. It is either a single object or a list of objects.
  • If delete is True the source objects are deleted.
  • force forces a certain way of downgrading by calling a specific internal function. It can be: "explode", "shapify", "subtr", "splitFaces", "cut2", "getWire", "splitWires" or "splitCompounds".
  • downgrade_list is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If delete is True the second list is empty.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

circle = Draft.make_circle(1000)
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()

add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=True)

compound = add_list1[0]
add_list2, delete_list2 = Draft.downgrade(compound, delete=False)
face = add_list2[0]
add_list3, delete_list3 = Draft.downgrade(face, delete=False)

box = doc.addObject("Part::Box", "Box")
box.Length = 2300
box.Width = 800
box.Height = 1000

add_list4, delete_list4 = Draft.downgrade(box, delete=True)

doc.recompute()